<script lang="ts" setup>
import { computed, nextTick, onMounted, ref, watch } from 'vue'
import type { VForm } from 'vuetify/components'
import { useBranchStore } from '@/stores/branch'
import type { Branch } from '@/types/Branch'
import { useMapStore } from '@/stores/map'
import MapView from '@/views/Management/MapView.vue'

const branchStore = useBranchStore()
const mapStore = useMapStore()

const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Address',
    key: 'address',
    value: 'address'
  },
  {
    title: 'City',
    key: 'city',
    value: 'city'
  },
  {
    title: 'Province',
    key: 'province',
    value: 'province'
  },
  {
    title: 'Postal Code',
    key: 'postalCode',
    value: 'postalcode'
  },
  {
    title: 'Country',
    key: 'country',
    value: 'country'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)

function onSubmit() {}
onMounted(async () => {
  await branchStore.getBranches()
})
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    branchStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await branchStore.deleteBranch()
  closeDelete()
}
async function editItem(item: Branch) {
  if (!item.id) return
  await branchStore.getBranch(item.id)

  if (
    branchStore.editedBranch &&
    branchStore.editedBranch.latitude !== null &&
    branchStore.editedBranch.longitude !== null
  ) {
    console.log(branchStore.editedBranch.latitude, branchStore.editedBranch.longitude)
    if (mapStore.branchAddress === null) {
      mapStore.branchAddress = { lat: 0, lng: 0, name: '' }
    }
    mapStore.branchAddress.lat = branchStore.editedBranch.latitude
    mapStore.branchAddress.lng = branchStore.editedBranch.longitude
    mapStore.branchAddress.name = branchStore.editedBranch.name
  }
  dialog.value = true
}
async function deleteItem(item: Branch) {
  if (!item.id) return
  await branchStore.getBranch(item.id)
  dialogDelete.value = true
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    branchStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await branchStore.saveBranch()
  closeDialog()
}
</script>

<template>
  <v-data-table-virtual
    :headers="headers"
    :items="branchStore.branches"
    :sort-by="[{ key: 'calories', order: 'asc' }]"
    fixed-header
  >
    <template v-slot:top>
      <v-toolbar flat>
        <v-toolbar-title>My CRUD</v-toolbar-title>
        <v-divider class="mx-4" inset vertical></v-divider>
        <v-spacer></v-spacer>
        <v-dialog v-model="dialog" max-width="90%">
          <template v-slot:activator="{ props }">
            <v-btn class="mb-2" color="primary" dark v-bind="props"> New Item </v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span class="text-h5"> CRUD ROLE </span>
            </v-card-title>

            <v-card-text>
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" md="4" sm="6">
                      <v-text-field
                        v-model="branchStore.editedBranch.name"
                        label="Name"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="4" sm="6">
                      <v-text-field
                        v-model="branchStore.editedBranch.address"
                        label="Address no. street village subdistrict"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="4" sm="6">
                      <v-text-field
                        v-model="branchStore.editedBranch.city"
                        label="District"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="4" sm="6">
                      <v-text-field
                        v-model="branchStore.editedBranch.province"
                        label="Province"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="4" sm="6">
                      <v-text-field
                        v-model="branchStore.editedBranch.postalcode"
                        label="Postal Code"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="4" sm="6">
                      <v-text-field
                        v-model="branchStore.editedBranch.latitude"
                        label="Latitude"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="4" sm="6">
                      <v-text-field
                        v-model="branchStore.editedBranch.longitude"
                        label="Longitude"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12">
                      <v-card>
                        <v-card-title class="text-h5 d-flex justify-center pa-10">Map</v-card-title>
                        <v-row justify="center">
                          <map-view></map-view>
                        </v-row>
                        <v-row justify="center" style="padding-top: 10px; padding-bottom: 10px">
                          <v-btn
                            @Click="
                              () => {
                                branchStore.editedBranch.latitude = mapStore.lat
                                branchStore.editedBranch.longitude = mapStore.lng
                              }
                            "
                          >
                            get Lat and Lng
                          </v-btn>
                        </v-row>
                      </v-card>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
            </v-card-text>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Cancel </v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="save"> Save </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>
    <template v-slot:item.actions="{ item }">
      <v-icon class="me-2" size="small" @click="editItem(item)"> mdi-pencil </v-icon>
      <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
    </template>
    <template v-slot:no-data>
      <v-btn color="primary" @click="branchStore.getBranches"> Reset </v-btn>
    </template>
  </v-data-table-virtual>
</template>
